(function (window, document, navigator){

    // Player - это старый плеер.
    // Frame - это наш плеер.

    var
        version = '5.2a',
        host = 'moe.video',
        blocked = false,
        mvExcludeClass = 'mv-exclude',
        mvReplacingClass = 'mv-replacing-',
        mvLoaderClass = 'mv-loader-',

        mvRand =  Math.random(),
        mvToken = new Date().getTime() + mvRand,
        mvCanStat = mvRand <= 0.1,
        mvCanError = mvRand <= 0.1,

        isBot = /Googlebot|Yandex/.test(navigator.userAgent),
        isFile = window.location.protocol == 'file:',
        isMobile = /android|meego|webOS|iPhone|iPad|iPod|BlackBerry|IEMobile|Opera Mini/i.test(navigator.userAgent),
        isIE = (function() {
            var m = navigator.userAgent.match(/MSIE (9).0|MSIE (10)|rv:(11).0/);
            return (m) ? m[1] : 0;
        })(),
        canReplace = (function(){
            var l =  ['loaded', 'complete'];
            return (isIE && isIE <= 10) ? l : l.concat(['interactive']);
        })(),
        isReplacer = function(str) {
            return /(moevideo.net|playreplay.net|videochart.net|moe.video)\/js\/(vh_replaser.min|replacer).js/.test(str);
        },

        isVisible = function(obj) {
            if (obj == document) {
                return true
            }

            if (!obj || !obj.parentNode || obj.style.opacity === '0' || obj.style.visibility === 'hidden' || obj.style.display === 'none' || obj.clientWidth == 0) {
                return false;
            }

            return isVisible(obj.parentNode);
        },
        onScreen = function(el) {
            var rect = el.getBoundingClientRect(),
                vpH = (window.innerHeight || document.documentElement.clientHeight),
                st = document.body.scrollTop,
                y = document.body.scrollTop + rect.top;

            return (y < (vpH + st)) && (y > (st - rect.height));
        },

        parseUrlParams = function(url){
            var params, a = document.createElement('a');

            a.href = url;
            params = a.search;

            if (url.indexOf('#')>=0){
                params+=url.substr(url.indexOf('#'));
            }

            if (params.length > 0){
                params = params.substr(1);
                var tmp = params.split('&');
                params = {};
                for(var j= 0, total= tmp.length; j<total; j++){
                    var t = tmp[j].split('=');
                    params[t[0]] = t[1];
                }
                return params;
            } else {
                return false;
            }
        },
        createParamsFromGet = function(params) {
            var isCSS = (params.filter && /^(#|\.|!)/.test(params.filter)),
                platforms = (params.filter && !isCSS)
                    ? params.filter.replace('yt', 'youtu').replace(/\./g, '|')
                    : 'youtu|vimeo';

            // todo: Выпилить когда появится поддержка vk
            platforms = platforms.replace('kp', '').replace('vk', '').replace(/^\|/, '').replace(/\|\|/, '|').replace(/\|$/, '');

            return (params.pin) ? {
                pin: params.pin,
                platforms: platforms,
                type: (params.type) ? 'after' : 'replace',
                filter: (isCSS) ? params.filter : false
            } : null;
        },
        getParamsFromGet = function() {
            //Получим параметры с которыми вызывается скрипт
            var scripts = document.scripts;

            if (scripts.length > 0){
                for (var i= 0,cnt=scripts.length;i<cnt;i++){
                    if (isReplacer(scripts[i].src)) {
                        return createParamsFromGet(parseUrlParams(scripts[i].src));
                    }
                }
            }
        },

        extend = function(obj1, obj2) {
            for (var key in obj2) {
                if (obj2.hasOwnProperty(key)) {
                    obj1[key] = obj2[key];
                }
            }
            return obj1;
        },
        objToStr = function(data) {
            return Object.keys(data).map(function(key) {
                return key + '=' + data[key];
            }).join('&');
        },
        addListener = function(event, callback) {
            window.addEventListener(event, callback);
        },
        getByClass = function(className, all) {
            var els = document.getElementsByClassName(className);
            return (all) ? els : els[0];
        },
        appendHead = function(el) {
            document.head.appendChild(el);
        },
        printLoaderStyle = function() {
            var style = document.createElement('style');
            style.innerHTML = "@-webkit-keyframes load3{0%{-webkit-transform:rotate(0);transform:rotate(0)}100%{-webkit-transform:rotate(360deg);transform:rotate(360deg)}}@keyframes load3{0%{-webkit-transform:rotate(0);transform:rotate(0)}100%{-webkit-transform:rotate(360deg);transform:rotate(360deg)}}.mvp_loader{position:absolute;left:50%;top:50%;margin:-30px 0 0 -30px;width:60px;height:60px;background:url(data:image/svg+xml;charset=US-ASCII,%3Csvg%20version%3D%221.1%22%20xmlns%3D%22http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%22%20viewBox%3D%220%200%2060%2060%22%3E%3Ccircle%20fill%3D%22none%22%20stroke%3D%22%23000000%22%20stroke-width%3D%2210%22%20stroke-miterlimit%3D%2210%22%20cx%3D%2230%22%20cy%3D%2230%22%20r%3D%2225%22%2F%3E%3Cpath%20fill%3D%22%23FFFFFF%22%20d%3D%22M3%2C30.5C3.4%2C45.8%2C15.2%2C57.6%2C30.5%2C58c3.2%2C0.1%2C3.2-4.9%2C0-5C18%2C52.7%2C8.3%2C43%2C8%2C30.5C7.9%2C27.3%2C2.9%2C27.3%2C3%2C30.5%20L3%2C30.5z%22%2F%3E%3C%2Fsvg%3E) black center no-repeat;background-size:60px;display:block;-webkit-animation:load3 1.4s infinite linear;animation:load3 1.4s infinite linear;z-index:1}";
            appendHead(style);
        },
        xhrRequest = function(method, url, data, callback, error) {

            var xhr, scriptOk = false;

            if (isIE && isIE == 9) {

                xhr = document.createElement("script");
                xhr.src = url + '?' + data + '&callback=';

                if (callback) {
                    xhr.src += 'reCall';
                    window.reCall = function(result) {
                        scriptOk = true;
                        callback(result);
                    };
                    xhr.onreadystatechange = function() {

                        if (canReplace.indexOf(document.readyState) >= 0) {
                            this.onreadystatechange = null;
                            setTimeout(function() {
                                if (!scriptOk && error) {
                                    error();
                                }
                            }, 0);
                        }
                    };
                }
                document.head.appendChild(xhr);
            } else {

                xhr = ("onload" in new XMLHttpRequest()) ? new XMLHttpRequest() : new XDomainRequest();

                if (error) {
                    xhr.onabort = function() { error('onAborted', xhr.status, xhr.readyState); };
                    xhr.onerror = function() { error('onError', xhr.status, xhr.readyState); };
                }

                xhr.open(method, url, true);

                xhr.onreadystatechange = function() {

                    if (xhr.readyState == 4 && xhr.status == 200 && callback) {
                        if (xhr.responseText) {
                            callback(JSON.parse(xhr.responseText)); // Another callback here
                        } else if (error) {
                            error('responseText empty', xhr.status, xhr.readyState);
                        }
                    } else if (error && (xhr.status == 500 )) {
                        error('500 error', xhr.status, xhr.readyState);
                    }
                };

                xhr.setRequestHeader('Content-type', 'application/x-www-form-urlencoded');
                xhr.send(data);
            }
        },
        sendStat = function(data) {
            if (mvCanStat) {
                xhrRequest('POST', 'http://stat.moevideo.net/collect/replacer/replacer_stat', objToStr(data));
            }
        },
        sendError = function(data) {
            if (mvCanError) {
                xhrRequest('POST', 'http://stat.moevideo.net/collect/replacer/replacer_errors', objToStr(data));
            }
        },

        defaultConfig = {
            //platforms: 'youtu|censor|kinopoisk|tsn|twitch|ustream|vimeo|uppod',
            platforms: 'youtu|vimeo',
            type: 'replace',
            observer: true,
            autoReplace: true
        },
        config = {},
        map = {
            youtu: /((?:https?:\/\/|\/\/)(?:(?:(?:(?:\w+\.)?[yY][oO][uU][tT][uU][bB][eE](?:-nocookie)?\.com\/|(?:www\.)?deturl\.com\/www\.youtube\.com\/|(?:www\.)?pwnyoutube\.com\/|(?:www\.)?yourepeat\.com\/|tube\.majestyc\.net\/|youtube\.googleapis\.com\/)(?:.*?\#\/)?(?:(?:(?:v|embed|e)\/(?!videoseries))|(?:(?:(?:watch|movie)(?:_popup)?(?:\.php)?\/?)?(?:\?|\#!?)(?:.*?&)?v=)))|youtu\.be\/|(?:www\.)?cleanvideosearch\.com\/media\/action\/yt\/watch\?videoId=))?(!videoseries|!playlist|[0-9A-Za-z_-]{11})?(?:\?(?:.*?&)?list=)?((?:PL|LL|EC|UU|FL|RD|UL)?[0-9A-Za-z-_]{10,})/,
            //vk: /(?:https?:\/\/|\/\/)(?:(?:m\.)?vk\.com\/video_ext\.php\?.*?\boid=(-?\d+).*?\bid=(\d+)|(?:(?:m\.)?vk\.com\/(?:.+?\?.*?z=)?video|(?:www\.)?biqle\.ru\/watch\/)([^s].*?)(?:\?|%2F|$))/,
            //censor: /https?:\/\/(?:www\.)?censor\.net\.ua\/cnPlayer\.swf\?vf=(\S+)/,
            //kinopoisk: /kinopoisk.ru\/[^\/]+\?trid=(\d+)&film=(\d+)&tid=(\w.+).mp4/,
            //tsn: /https?:\/\/(?:\w+\.)?tsn.ua\/bin\/player\/embed.php|iframe\/(\d+)/,
            //twitch: /https?:\/\/(?:www\.)?twitch\.tv\/[^\/]+\/(c|b)\/(\d+)/,
            //ustream: /https?:\/\/www\.ustream\.tv\/(recorded|embed|embed\/recorded)\/(\d+)/,
            vimeo: /https?:\/\/(?:(?:www|player)\.)?vimeo(pro)?\.com\/(?!channels\/[^\/?#]+\/?(?:$|[?#])|album\/)(?:.*?\/)?(?:(?:play_redirect_hls|moogaloop\.swf)\?clip_id=)?(?:videos?\/)?([0-9]+)\/?(?:[?&].*)?(?:[#].*)?/
        },
        cssRule,

        timer = (function() {
            return {
                ajax: (isMobile) ? 15000 : 10000,
                frame: (isMobile) ? 45000 : 30000,
                ajaxPHP: 0,
                time: 0
            }
        })(),
        counter = 0,
        toSend = [],
        dataBase = {},

        getPlayerSrc = function(element) {
            var eleChild = {}, childNodes, name;

            element.className = (element.className) ? element.className + ' ' + mvExcludeClass : mvExcludeClass;

            if (element.tagName === 'IFRAME' || element.tagName === 'EMBED') {
                return element.src;
            }

            childNodes = element.childNodes;

            // Преобразовываем в массив
            for(var j=-1, l = childNodes.length; ++j!==l;) {
                if (childNodes[j].name) {
                    name = childNodes[j].name.toLowerCase();

                    if (name === "flashvars" ||  name === "movie" ||  name === "src") {
                        eleChild[name] = childNodes[j].value;
                    }
                }
            }

            if (eleChild.hasOwnProperty('src')) {
                return decodeURIComponent(eleChild.src);
            }

            if (eleChild.hasOwnProperty('flashvars')) {

                if (eleChild.hasOwnProperty('movie')) {
                    // Поддержка Uppod
                    if (/up(pod)?\.swf/.test(eleChild.movie)) {

                        name = /file=([^&]+)/.exec(eleChild.flashvars)[1];

                        // На случай относительных путей
                        if (name[0] == '/' && name[1] != '/') {
                            name = "//" + window.location.host + name;
                        }

                        return name;
                    }

                    // Поддержка Censor
                    if (/\.ua\/cnPlayer\.swf/.test(eleChild.movie)) {
                        return eleChild.movie;
                    }
                }

                return decodeURIComponent(eleChild.flashvars);
            }

            if (eleChild.hasOwnProperty('movie')) {
                return decodeURIComponent(eleChild.movie);
            }

            return false;
        },
        getVideoParams = function(module, url) {
            var data = {
                    vh: module
                },
                matches;

            if (['.mp4', '.flv'].indexOf(module) != -1) {
                return {
                    vh: 'file',
                    id: url
                };
            }

            matches = url.match(map[module]);

            if (matches !== null) {

                switch (module) {
                    //case 'vk':
                    //    data.id = (matches[3]) ? matches[3] : matches[1] + '_' + matches[2];
                    //    break;
                    //case 'kinopoisk':
                    //    data.id = matches[1] + '_' + matches[2] + '_' + matches[3];
                    //    break;
                    //case 'censor':
                    //case 'tsn':
                    //    data.id =  matches[1];
                    //    break;
                    //case 'twitch':
                    //    data.id = ((matches[1] === 'b') ? 'a' : 'c') + matches[2];
                    //    break;
                    case 'youtu':
                        if (matches[2]) { data.list = matches[2]; }
                        if (matches[3] && matches[1]) { data.id = matches[3]; }
                        break;
                    default: //  vimeo, ustream
                        data.id = matches[2];
                }

                //todo Выпиливаем листы в youtube. Когда появится поддержка - убрать.
                if (data.list || !(data.vh && data.id)) { return null; }

                return data;
            }

            return null;
        },
        getFreeVideoParams = function(src, image) {
            return {
                id: String('syslik-' + counter++),
                vh: 'file',
                video: src,
                image: (image == undefined) ? '' : image
            }
        },
        hidePlayer = function(player) {
            player.src = '';
            player.style.display = 'none';
        },
        getFrameData = function(src, forsed, image) {
            var rule = new RegExp('(' + config.platforms + '|\.mp4|\.flv)'),
                data = null, matches, frame;

            if (src) {
                matches = src.match(rule);
                data = (matches !== null) ? getVideoParams(matches[1], src) : ((forsed) ? getFreeVideoParams(src, image) : null);

                if (data) {
                    frame = document.createElement('iframe');
                    //frame.id = data.id || data.list;
                    frame.setAttribute('frameborder', '0');
                    frame.setAttribute('allowfullscreen', true);

                    data.frame = frame;
                    data.index = counter;
                }
            }

            return data;
        },
        workWith = function(player) {
            var src = getPlayerSrc(player),
                data = getFrameData(src),
                style, elem, loader, inDB, iden,
                newStyle = {
                    width: parseInt(player.width) || false,
                    height: parseInt(player.height) || false
                };

            if (data) {
                data.src = player.src;
                data.isVisible = isVisible(player);
                data.onScreen = onScreen(player);
                data.stopped = false;
                data.startTime = new Date().getTime();

                // Получаем точный стиль текущего фрейма
                style = player.currentStyle || window.getComputedStyle(player);
                newStyle.width = (style.width == 'auto' && player.width) ? ((newStyle.width != player.width) ? player.width : newStyle.width+'px') : style.width;
                newStyle.height = (style.width == 'auto' && player.height) ? ((newStyle.height != player.height) ? player.height : newStyle.height+'px') : style.height;
                newStyle = 'width:'+newStyle.width+';height:'+newStyle.height+';margin:'+style.margin;
                data.display = style.display;

                if (config.type === 'replace') { hidePlayer(player); }

                // Создание лоадера
                elem = document.createElement('div');
                elem.setAttribute('class', 'mvp_loader');
                loader = document.createElement('div');
                loader.appendChild(elem);
                loader.setAttribute('class', 'mv-load ' + mvLoaderClass + data.index);
                loader.setAttribute('style', 'background: black;position: relative;' + newStyle);
                loader.style.display = 'inline-block';

                player.className += ' ' + mvReplacingClass + data.index;
                player.parentNode.appendChild(loader);

                data.frame.setAttribute('class', (player.className) ? player.className + ' ' + mvExcludeClass : mvExcludeClass);
                data.frame.setAttribute('style', (player.getAttribute('style')) ? player.getAttribute('style') +';'+newStyle : newStyle);

                dataBase[mvReplacingClass + data.index] = data;

                iden = {
                    index: data.index,
                    id: data.id,
                    vh: data.vh
                };

                inDB = findInDB(iden);
                counter++;

                if (inDB || data.vh == 'file') {
                    iden.url = inDB || '//playreplay.me/framevideo?pin=' + ((config.pin) ? config.pin : 0) + '&video='+data.id;
                    replaceContinue(iden);
                } else {
                    toSend.push(iden);
                }
            }
        },

        replaceVHs = function() {

            if(!cssRule) {
                var css = '',
                    pattern = '.' + mvExcludeClass,
                    filter = config.filter,
                    cssLine = 'iframe:not(:c):s,object:not(:c):s,:not(object)>embed:not(:c):s',
                    cssLine2 = ':s iframe:not(:c),:s object:not(:c),:s :not(object)>embed:not(:c),:s:not(object)>embed:not(:c)';

                if (filter){
                    if (filter.indexOf('!') == 0) {
                        pattern = filter.split('!')[1];
                    } else {
                        cssLine = (/^([^a-zA-Z0-9])/.test(filter)) ? cssLine + ',' + cssLine2 : cssLine2;
                        css = filter;
                    }
                }

                cssRule = cssLine.replace(/:s/g, css).replace(/:c/g, pattern);
            }

            replacePlayers(document.querySelectorAll(cssRule));
        },
        replacePlayers = function(players) {

            if (players.length > 0) {
                printLoaderStyle();
            }

            for (var i = 0, ln = players.length; i < ln; i++) {
                workWith(players[i]);
            }

            if (toSend.length > 0) {
                timer.time = setTimeout(function() {
                    replaceError('API timeout');
                }, timer.ajax);
                xhrRequest('POST', '//'+host+'/data', objToStr({
                    r: JSON.stringify([["replacer/get_urls", [config.pin, toSend]]])
                }), replaceCallback, replaceError);
                toSend = [];
            } else if (toSend.length == 0 && counter > 0) {
                sendStat({
                    ver: version,
                    mvToken: mvToken,
                    url: window.location.href,
                    localAPI: true
                });
            }
        },
        replaceCallback = function(request) {
            clearTimeout(timer.time);

            if (request.status = 'ok' && request.data[0] && request.data[0] instanceof Array) {
                timer.ajaxPHP = request.time;
                request.data[0].forEach(replaceContinue);
                addToDB(request.data[0]);
            } else {
                replaceError('request data not array or status not ok', 200, 4);
            }
        },
        replaceContinue = function(data) {
            var parent, frame, player,
                className = mvReplacingClass + data.index;

            if (dataBase[className] && !dataBase[className].stopped) {

                frame = dataBase[className].frame;

                dataBase[className].ajaxTime = new Date().getTime();
                frame.src = data.url+'&index='+data.index+'&version=2&bla';

                player = getByClass(className);
                parent = player.parentNode;
                dataBase[className].timer = setTimeout(function() {
                    rollbackPlayerStat(dataBase[className]);
                }, timer.frame);

                (config.type === 'after' && !player.nextSibling) ? parent.appendChild(frame) : parent.insertBefore(frame, (config.type !== 'after') ? player : player.nextSibling);
            }
        },
        replaceError = function(reason, status, state) {
            clearTimeout(timer.time);

            for(var p in dataBase) {
                if (dataBase.hasOwnProperty(p)) {
                    rollbackPlayer(dataBase[p]);
                }
            }

            sendError({
                ver: version,
                mvToken: mvToken,
                slug: 'rollback-multiple',
                reason: reason,
                state: state,
                status: status,
                text: 'Full rollback changes',
                url: window.location.href,
                host: window.location.host
            });
        },
        rollbackPlayer = function(data) {
            var className = mvReplacingClass + data.index,
                player = getByClass(className);

            data.stopped = true;

            player.src = data.src;
            player.style.display = 'block';

            getByClass(mvLoaderClass+data.index).style.display = 'none';
        },
        rollbackPlayerStat = function(data) {
            rollbackPlayer(data);
            sendError({
                ver: version,
                mvToken: mvToken,
                slug: 'rollback-single',
                text: 'Single timeout rollback',
                url: window.location.href,
                totalCount: counter,
                isMobile: isMobile,
                host: window.location.host
            });
        },

        postListener = function(event) {
            var data, player,
                can = (typeof event.data === 'string') && (/^MoeVideo:/.test(event.data));

            if (can) {
                data = event.data.split(':');

                if (dataBase[mvReplacingClass + data[2]]) {

                    player = dataBase[mvReplacingClass + data[2]];

                    switch (data[1]) {
                        case 'start':
                            onFrameInteractive(player, data[3]);
                            break;
                        case 'loaded':
                            onFrameLoaded(player, data[2]);
                            break;
                    }
                }
            }
        },
        onFrameInteractive = function(player, phpDelta) {
            player.loadingTime = new Date().getTime();
            player.phpDelta = phpDelta;
        },
        onFrameLoaded = function(player, i) {
            clearTimeout(dataBase[mvReplacingClass + i].timer);
            getByClass(mvLoaderClass + i).style.display = 'none';
            player.endTime = new Date().getTime();
            player.frame.style.display = player.display;

            sendStat({
                ver: version,
                mvToken: mvToken,
                // Общая информация о странице
                url: window.location.href,
                isVisible: player.isVisible,
                onScreen: player.onScreen,
                activeWindow: (document.visibilityState|| document.mozVisibilityState|| document.msVisibilityState|| document.webkitVisibilityState) == 'visible',
                filter: config.filter,
                totalCount: counter,
                isMobile: isMobile,
                // Информация о фрейме
                vh: player.vh,
                index: player.index,
                // Статистические таймеры
                timeStartToEnd: player.endTime - player.startTime,
                timeStartToFrame: player.loadingTime - player.startTime,
                timeFramePHP: player.phpDelta,
                timeFrameToEnd: player.endTime - player.loadingTime,
                timeAjax: player.ajaxTime - player.startTime,
                timeAjaxPHP: timer.ajaxPHP
            });
        },
        onError = function(e) {
            if (isReplacer(e.filename)) {
                sendError({
                    ver: version,
                    mvToken: mvToken,
                    slug: 'error-js',
                    line: e.lineno,
                    text: e.message,
                    filename: e.filename,
                    error: e.error,
                    url: window.location.href,
                    host: window.location.host
                });

                for(var p in dataBase) {
                    if (dataBase.hasOwnProperty(p)) {
                        rollbackPlayer(dataBase[p]);
                    }
                }
            }
        },
        onReadyState = function() {
            if (!blocked && canReplace.indexOf(document.readyState) >= 0) {
                config = extend(defaultConfig, config);
                replaceVHs();
                blocked = true;
            }
        },
        startReplacer = function() {
            (canReplace.indexOf(document.readyState) >= 0) ?  onReadyState() : document.onreadystatechange = onReadyState;
        },

        ls = window.localStorage || 0,
        iRep = (function(){
            var db = {};

            if (ls) {
                db = JSON.parse(ls.getItem("iRep")) || {};
            }

            return db;
        })(),
        findInDB = function(iden) {
            var key = iden.vh+'-'+iden.id;
            return (iRep[key]) ? iRep[key] : 0;
        },
        clearDB = function() {
            iRep = {};
            saveIntoDB();
        },
        saveIntoDB = function() {
            if (ls) {
                ls.setItem("iRep", JSON.stringify(iRep));
            }
        },
        addOneToDB = function(iden) {
            if (iden.cache) {
                var key = iden.vh+'-'+iden.id;
                iRep[key] = iden.url;
            }
        },
        addToDB = function(rows) {
            if (Object.keys(rows).length > 1000) {
                clearDB();
            }
            rows.forEach(addOneToDB);
            saveIntoDB();
        },

        observer = function() {
            setTimeout(function() {
                var observer = new MutationObserver(mutationsObserve),
                    target = document.body;

                config = extend(defaultConfig, {});

                observer.observe(target, {
                    subtree: true,
                    childList: true
                });
            }, 0);
        },
        mutationsObserve = function(mutations) {
            mutations.forEach(mutationObserve);
        },
        mutationObserve = function(mutation) {
            var cnt=mutation.addedNodes.length, el,
                toReplace = [];

            if (cnt > 0 ) {
                for (var i= 0; i<cnt; i++){
                    el = mutation.addedNodes[i];

                    if (el.tagName === 'IFRAME' || el.tagName === 'EMBED' || el.tagName === 'OBJECT'
                        || (el.querySelectorAll && el.querySelectorAll('iframe, object').length > 0)) {
                        replaceVHs();
                    }
                }
            }
        },

        Replacer = function(opt) {
            // Присланные параметры должны стать дефолтными.
            // Далее подгружаем из дефолта
            defaultConfig = extend(defaultConfig, opt);

            if (opt.autoReplace) {
                startReplacer();
            }

            if (opt.observer) {
                observer();
            }
        };

    Replacer.version = version;

    Replacer.replace = function(opt) {
        opt = opt || {};
        config = extend(defaultConfig, opt);
        cssRule = null;
        replaceVHs();
    };

    Replacer.create = function(target, src, opt) {
        var data;

        opt = opt || {};
        config = extend(defaultConfig, opt);
        data = getFrameData(src, true, opt.image);

        if (data) {

            data.startTime = new Date().getTime();
            data.frame.width = opt.width || 640;
            data.frame.height = opt.height || 360;
            data.frame.src = '//playreplay.me/framevideo?vh='+data.vh+'&pin=' + ((config.pin) ? config.pin : 0) + '&id='+data.id+'&index='+counter+'&blabla';
            data.frame.setAttribute('class', ((opt.className) ? opt.className + ' ' : '') + mvExcludeClass);
            dataBase[mvReplacingClass + data.index] = data;

            ((typeof target === 'string') ? document.getElementById(target) : target).appendChild(data.frame);

            counter++;
        }

        return data.frame;
    };

    if (!window.MoeVideo && !isBot && !isFile) {

        console.log('Replacer ' + version);

        window.MoeVideo = {
            Replacer: Replacer
        };

        window.mv_vh_replaser = function() {
            blocked = false;
            onReadyState();
        };

        addListener('error', onError);
        addListener('message', postListener);

        config = getParamsFromGet();
        if (config) {
            defaultConfig = extend(defaultConfig, config);
            startReplacer();
        }
    }

})(window, document, navigator);